unit InterfaceTestMainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  InterfaceTestImplU, InterfaceTestIntfU;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  Hello: THello;
begin
  Hello := THello.Create;
  Hello.SayHi;
  Hello.Free
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Hello: IHello;
begin
  Hello := THello.Create;
  Hello.SayHi
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Hello: IHello;
  Hello2: IHelloGoodbye;
begin
  Hello := THello.Create;
  Hello.SayHi;
  Hello := THello2.Create;
  Hello.SayHi;
  if Succeeded(Hello.QueryInterface(IHelloGoodbye, Hello2)) then
    Hello2.SayBye
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  Hello: IHello;
  Hello2: IHelloGoodbye;
begin
  Hello := THello.Create;
  Hello.SayHi;
  Hello := THello2.Create;
  Hello.SayHi;
  //if Succeeded(Hello.QueryInterface(IHelloGoodbye, Hello2)) then
  //  Hello2.SayBye
  Hello2 := Hello as IHelloGoodbye;
  Hello2.SayBye
end;

end.
